import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import invariant from 'invariant';
import { OrderedMap } from 'extendable-immutable';

export var Collection = function (_OrderedMap) {
  _inherits(Collection, _OrderedMap);

  Collection.of = function of(val) {
    return new Collection(val);
  };

  Collection.isCollection = function isCollection(val) {
    return val && val instanceof Collection;
  };

  function Collection(val) {
    var dependencies = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

    _classCallCheck(this, Collection);

    var _this = _possibleConstructorReturn(this, _OrderedMap.call(this, val));

    _this.dependencies = dependencies;
    return _this;
  }

  Collection.prototype.__wrapImmutable = function __wrapImmutable() {
    var _OrderedMap$prototype;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var res = (_OrderedMap$prototype = _OrderedMap.prototype.__wrapImmutable).call.apply(_OrderedMap$prototype, [this].concat(args));
    res.dependencies = this.dependencies;

    return res;
  };

  // Returns Collection with only incomplete items


  Collection.prototype.filterComplete = function filterComplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && !(!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  // Returns Collection with only complete items


  Collection.prototype.filterIncomplete = function filterIncomplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && (!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  return Collection;
}(OrderedMap);

export default function createCollection(obj, dependencies) {
  return new Collection(obj, dependencies);
}