'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Collection = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = createCollection;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _extendableImmutable = require('extendable-immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Collection = exports.Collection = function (_OrderedMap) {
  (0, _inherits3.default)(Collection, _OrderedMap);

  Collection.of = function of(val) {
    return new Collection(val);
  };

  Collection.isCollection = function isCollection(val) {
    return val && val instanceof Collection;
  };

  function Collection(val) {
    var dependencies = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
    (0, _classCallCheck3.default)(this, Collection);

    var _this = (0, _possibleConstructorReturn3.default)(this, _OrderedMap.call(this, val));

    _this.dependencies = dependencies;
    return _this;
  }

  Collection.prototype.__wrapImmutable = function __wrapImmutable() {
    var _OrderedMap$prototype;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var res = (_OrderedMap$prototype = _OrderedMap.prototype.__wrapImmutable).call.apply(_OrderedMap$prototype, [this].concat(args));
    res.dependencies = this.dependencies;

    return res;
  };

  // Returns Collection with only incomplete items


  Collection.prototype.filterComplete = function filterComplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && !(!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  // Returns Collection with only complete items


  Collection.prototype.filterIncomplete = function filterIncomplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && (!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  return Collection;
}(_extendableImmutable.OrderedMap);

function createCollection(obj, dependencies) {
  return new Collection(obj, dependencies);
}